#include "dtc.h"

DTCEntry_s DTCStorage[MAX_DTC_STORAGE];

void MaintainDTC(uint32_t DTC_no, boolean active)
{
    for (int i = 0; i < MAX_DTC_STORAGE; i++)
    {
        if (DTCStorage[i].Number == DTC_no)
        {
            if (active == true)
            {
                DTCStorage[i].timestamp = millis();
                DTCStorage[i].active = DTC_ACTIVE;
                return;
            }
            else
            {
                DTCStorage[i].active = DTCStorage[i].active == DTC_ACTIVE ? DTC_PREVIOUS : DTC_NONE;
                return;
            }
        }
    }

    // DTC was not found with upper iteration, but is active
    // so we need to look for free space to store DTC
    if (active == true)
    {
        for (int i = 0; i < MAX_DTC_STORAGE; i++)
        {
            if (DTCStorage[i].Number == 0)
            {
                DTCStorage[i].timestamp = millis();
                DTCStorage[i].active = DTC_ACTIVE;
                return;
            }
        }
    }
}

void ClearDTC(uint32_t DTC_no)
{
    for (int i = 0; i < MAX_DTC_STORAGE; i++)
    {
        if (DTCStorage[i].Number == DTC_no)
        {
            DTCStorage[i].Number = 0;
        }
    }
}

void ClearAllDTC()
{
    for (int i = 0; i < MAX_DTC_STORAGE; i++)
        DTCStorage[i].Number = 0;
}

uint32_t getlastDTC(boolean only_active)
{
    uint8_t pointer = 0;
    uint32_t lasttimestamp = 0;

    for (int i = 0; i < MAX_DTC_STORAGE; i++)
    {
        if (DTCStorage[i].Number > 0 && DTCStorage[i].timestamp > lasttimestamp)
        {
            if (only_active == false || DTCStorage[i].active == DTC_ACTIVE)
            {
                pointer = i;
                lasttimestamp = DTCStorage[i].timestamp;
            }
        }
    }

    return pointer > 0 ? DTCStorage[pointer].Number : 0;
}
